"""
Organize the top 5 hits of each sRNA for
CopraRNA into a single .csv that can
be easily copy/pasted into excel
"""

import os

def main():
    path = os.getcwd()[:-7]
    sRNA_ID = "M81"     # Insert sRNA name
    dir = path + "CopraRNA/" + sRNA_ID + "/"
    infilename = dir + sRNA_ID + "_results.csv"
    outfilename = dir + sRNA_ID + "_summary.csv"
    
    """
    data = [fdr,
            p-value,            CopraRNA p-value
            NC_003028,          pneumoniae (TIGR4)
            NZ_CP044221,        mutans
            NC_012926,          suis
            NZ_LS483338,        pyogenes
            Annotation,
            Additional homologs,
            Amount sampled
            ]
    """
    
    organisms = {2: "S. pneumoniae (TIGR4)",
                 3: "S. mutans",
                 4: "S. suis",
                 5: "S. pyogenes",}

    def writeData(information):
        information[5] = information[5][:-1].split("|")
        for item in information:
            if item is information[5]:
                if len(item) == 1:
                    for _ in range(8):
                        outfile.write("N/A;")
                else:
                    for info in information[5]:
                        outfile.write(str(info) + ";")
            else:   
                outfile.write(str(item) + ";")
        outfile.write("\n")
        # sRNA_ID
        # Rank
        # Organism
        # CopraRNA p-val
        # Locus tag
        # Gene name
        # Energy
        # IntaRNA p-val
        # mRNA_start
        # mRNA_end
        # sRNA_start
        # sRNA_end
        # Gene_ID
        # Annotation
    
    with open(infilename) as infile:
        infile.readline()
        with open(outfilename, "w") as outfile:
            # outfile.write("sep=;")
            outfile.write("sRNA_ID;Rank;Organism;CopraRNA_p-val;Locus_tag;Gene_name;Energy;IntaRNA_p-val;mRNA_start;mRNA_end;sRNA_start;sRNA_end;Gene_ID;Annotation\n")
            for rank in range(1, 6):
                data = infile.readline().split(",")
                for i in range(2, 6):
                    try:
                        locus, organism = data[i].split("(")
                    except:
                        locus, organism = "N/A", "N/A"
                    information = [sRNA_ID, rank, organisms[i], data[1], locus, organism, data[6]]
                    writeData(information)

main()