"""
Report the most significant alignment for each sRNA
in each of the 3 Streptococcus species (pyogenes, 
mutans, suis).
Output the identities and gaps of each top alignment
for each sRNA for each species to a file called
blast_results_summary.txt.
"""

import os
import helper_functions as hf

def get_top_hit(infile):
    hf.skip_lines(infile, 4)
    identities = infile.readline()[1:]
    hf.skip_lines(infile, 2)
    for _ in range(3):
        identities += infile.readline()
    return identities

def main():
    path = os.getcwd()[:-7]
    directory = path + "pyogenes mutans suis/"
    file = directory + "blast_results.txt"
    infile = open(file)
    output = directory + "blast_results_summary.txt"
    outfile = open(output, "w")

    hf.skip_lines(infile, 15)
    while(1):
        line = infile.readline().strip()
        if "Database" in line: break
        name = line.split("=")[1]
        hf.skip_lines(infile)
        length = infile.readline().strip().split("=")[1]
        hf.skip_lines(infile, 3)
        outfile.write("Name: " + name + ", Length: " + length + "\n")
        line = infile.readline()
        streps = []
        while line[0] == "N":
            streps.append(line.split(" ")[2])
            line = infile.readline()
        hf.skip_lines(infile)
        for i in range(len(streps)):
            while infile.readline()[1:6] != "Score": continue
            identities = infile.readline()[1:]
            outfile.write("Strain: " + streps[i] + ", " + identities)
            hf.skip_lines(infile, 2)
            while infile.readline()[0] != ">" and i < len(streps) - 1: continue
        outfile.write("\n")
        while infile.readline()[:9] != "Effective": continue
        hf.skip_lines(infile, 2)
            
    infile.close()
    outfile.close()

main()