"""
Organize the top hit of each sRNA for
TargetRNA3 into a single .tsv that can
be easily copy/pasted into excel
"""

import os

def main():
    path = os.getcwd()[:-7]
    strain = "suis"
    results = path + "pyogenes mutans suis/" + strain + "_results/"
    outfile = results + strain + "_summary.tsv"
    
    sRNAs = dict()
    
    for filename in os.listdir(results):
        if filename[-4:] == ".txt":
            infile = results + filename
            with open(infile) as file:
                name = filename.split("_")[0]
                file.readline()
                line = file.readline()
                sRNAs[name] = line
    
    with open(outfile, "w") as file:
        # 81 for the highest number identifier for any of the sRNAs (M81)
        # This is for sorting them from M1 -> M2 -> ... -> M81
        for i in range(82):
            name = ("M" + str(i))
            if name in sRNAs:
                file.write(name + "\t" + sRNAs[name])

main()