"""
Get the sequences for the putative sRNAs from the
D39W study (Sinha) using the provided coordinates
This list is only contains the putative sRNAs that
were also found in the other studies (at least 1
other study) or confirmed by Northern/qRT-PCR
D39W genome: CP000410.1
"""

import os
import helper_functions as hf

def main():
    path = os.getcwd()[:-7]
    d39 = path + "Other fasta files/D39W.fasta"
    d39_srnas = path + "sRNA data/D39W_sRNAs.txt"
    outfilename = path + "sRNA data/D39W_seqs.fasta"
    infile1 = open(d39)
    infile2 = open(d39_srnas)
    outfile = open(outfilename, "w")
    
    for _ in range(2):
        infile2.readline()
    line = infile2.readline()
    while True:
        if not line:
            break
        d39_name, study_names, coordinates, strand = line.split(" ")
        strand = strand[1]
        start, end = coordinates.split("-")
        sequence = hf.retrieve_sequence(int(start), int(end), infile1)
        if strand == "-":
            sequence = hf.reverse_complement(sequence)
        outfile.write(">" + d39_name + "|" + study_names + "|" + start + "-" + end + "|" + strand + "\n" + sequence + "\n\n")
        line = infile2.readline()

    infile1.close()
    infile2.close()
    outfile.close()

main()