"""
Get the sequences for the putative sRNAs from the
Mann study (TIGR4) using the provided coordinates
TIGR4 genome: NC_003028.3
"""

import os
import helper_functions as hf

def main():
    path = os.getcwd()[:-7]
    tigr4 = path + "Other fasta files/TIGR4.fasta"
    mann_coords = path + "sRNA data/Mann_coords.txt"
    outfilename = path + "sRNA data/Mann_seqs.fasta"
    infile1 = open(tigr4)
    infile2 = open(mann_coords)
    outfile = open(outfilename, "w")
    
    for _ in range(2):
        infile2.readline()
    line = infile2.readline()
    while line:
        if not line:
            break
        name, coordinates = line.split("\t")
        strand = name[0]
        start, end = coordinates.split("-")
        sequence = hf.retrieve_sequence(int(start), int(end), infile1)
        if strand == "R":
            sequence = hf.reverse_complement(sequence)
        outfile.write(">" + name + "|" + start + "-" + end + sequence + "\n\n")
        line = infile2.readline()

    infile1.close()
    infile2.close()
    outfile.close()

main()