"""
Find the old loci names of the TargetRNA3
TIGR4 targets for analyzing the distribution
of location
"""

import os

def getLocus(infile, locus):
    infile.seek(0)
    while locus not in infile.readline(): continue
    try:
        tag = infile.readline().split('"')[1]
    except:
        tag = ""
    return tag

def main():
    path = os.getcwd()[:-7]
    targetrna = path + "TargetRNA3 stuff/"
    strain = "TIGR4"
    txt1 = targetrna  + "All_TIGR4_new_loci.txt"
    txt2 = targetrna  + "All_TIGR4_new_loci_highprob.txt"
    genbank = path + "Annotated genomes/" + strain + ".gb"
    # These correspond to the regular file
    output1 = targetrna + "/All_TIGR4_old_loci_withdupes1.txt"
    output2 = targetrna + "/All_TIGR4_old_loci_nodupes1.txt"
    # These correspond to the high prob file
    output3 = targetrna + "/All_TIGR4_old_loci_withdupes2.txt"
    output4 = targetrna + "/All_TIGR4_old_loci_nodupes2.txt"
    
    new_loci_nd1 = list()
    new_loci_wd1 = set()
    with open(txt1) as infile:
        locus = infile.readline().strip()
        while locus:
            if " " in locus:
                locus = locus.split(" ")[1][1:-1]
            new_loci_nd1.append(locus)
            new_loci_wd1.add(locus)
            locus = infile.readline().strip()
            
    new_loci_nd2 = list()
    new_loci_wd2 = set()
    with open(txt2) as infile:
        locus = infile.readline().strip()
        while locus:
            if " " in locus:
                locus = locus.split(" ")[1][1:-1]
            new_loci_nd2.append(locus)
            new_loci_wd2.add(locus)
            locus = infile.readline().strip()
    
    with open(genbank) as infile:
        with open(output1, "w") as outfile:
            for locus in new_loci_nd1:
                old_locus = getLocus(infile, locus)
                if old_locus != "":
                    outfile.write(old_locus + "\n")
        with open(output2, "w") as outfile:
            for locus in new_loci_wd1:
                old_locus = getLocus(infile, locus)
                if old_locus != "":
                    outfile.write(old_locus + "\n")
        with open(output3, "w") as outfile:
            for locus in new_loci_nd2:
                old_locus = getLocus(infile, locus)
                if old_locus != "":
                    outfile.write(old_locus + "\n")
        with open(output4, "w") as outfile:
            for locus in new_loci_wd2:
                old_locus = getLocus(infile, locus)
                if old_locus != "":
                    outfile.write(old_locus + "\n")

main()