"""
Get the sequences for the putative sRNAs from the
Sinha study (D39) using the provided coordinates
D39 genome: NC_008533.2
"""

import os
import helper_functions as hf

def main():
    path = os.getcwd()[:-7]
    d39 = path + "Other fasta files/D39.fasta"
    sinha_coords = path + "sRNA data/Sinha_coords.txt"
    outfilename = path + "sRNA data/Sinha_seqs.fasta"
    infile1 = open(d39)
    infile2 = open(sinha_coords)
    outfile = open(outfilename, "w")
    
    for _ in range(2):
        infile2.readline()
    line = infile2.readline()
    while line:
        if not line:
            break
        try:
            name, coordinates, strand = line.split("\t")
        except:
            name, tab, coordinates, strand = line.split("\t")
        strand = strand[1]
        start, end = coordinates.split("-")
        sequence = hf.retrieve_sequence(int(start), int(end), infile1)
        if strand == "-":
            sequence = hf.reverse_complement(sequence)
        outfile.write(">" + name + "|" + start + "-" + end + "|" + strand + "\n" + sequence + "\n\n")
        line = infile2.readline()

    infile1.close()
    infile2.close()
    outfile.close()
    
main()