"""
Get the sequences for the putative sRNAs from the
TIGR4 studies (Mann and Acebo) using the provided
coordinates
This list is only contains the putative sRNAs that
were also found in the other studies (at least 1
other study) or confirmed by Northern/qRT-PCR
TIGR4 genome: NC_003028.3
"""

import os
import helper_functions as hf

def main():
    path = os.getcwd()[:-7]
    tigr4 = path + "Other fasta files/TIGR4.fasta"
    tigr4_srnas = path + "sRNA data/TIGR4_sRNAs.txt"
    outfilename = path + "sRNA data/TIGR4_seqs.fasta"
    infile1 = open(tigr4)
    infile2 = open(tigr4_srnas)
    outfile = open(outfilename, "w")
    
    for _ in range(2):
        infile2.readline()
    line = infile2.readline()
    while True:
        if not line:
            break
        tigr4_name, study_names, coordinates, strand = line.split(" ")
        strand = strand[1]
        start, end = coordinates.split("-")
        sequence = hf.retrieve_sequence(int(start), int(end), infile1)
        if strand == "-":
            sequence = hf.reverse_complement(sequence)
        outfile.write(">" + tigr4_name + "|" + study_names + "|" + start + "-" + end + "|" + strand + "\n" + sequence + "\n\n")
        line = infile2.readline()
    
    infile1.close()
    infile2.close()
    outfile.close()

main()