"""
A file that contains all the functions
used in the scripts
"""

from typing import IO

def complement(seq: str) -> str:
    seq = seq.replace("A", "?")
    seq = seq.replace("T", "A")
    seq = seq.replace("?", "T")
    seq = seq.replace("C", "?")
    seq = seq.replace("G", "C")
    seq = seq.replace("?", "G")
    return seq

def reverse(seq: str) -> str:
    return seq[::-1]

def reverse_complement(seq: str) -> str:
    return reverse(complement(seq))

def RNA_to_DNA(seq: str) -> str:
    return seq.replace("U", "T")

def DNA_to_RNA(seq: str) -> str:
    return seq.replace("T", "U")

def retrieve_sequence(start: int, end: int, infile: IO[str], upstream: int = 0, downstream: int = 0) -> str:
    seq = ""
    infile.seek(0)
    infile.readline()
    line_length = len(infile.readline().strip())
    infile.seek(0)
    infile.readline()
    position = 1
    num_lines = (start - upstream) // line_length
    if start - upstream > 0:
        for _ in range(num_lines):
            infile.readline()
        position = num_lines * line_length + 1
    while position <= start - upstream - 1:
        if infile.read(1) != "\n":
            position += 1
    while position <= end + downstream:
        char = infile.read(1)
        if not char:
            break
        if char != "\n":
            seq += char
            position += 1
    return seq

def skip_lines(infile: IO[str], num: int = 1) -> None:
    for _ in range(num): infile.readline()