"""
Using the RNAfold results and interaction
in the IntaRNATopHit csv file compare the
structure to determine if basepairing is
occurring in structured regions
"""
import os

def main():
    path = os.getcwd()[:-7]
    intaRNA = path + "IntaRNA stuff/"
    strains = ["D39",
               "TIGR4",
               "TVO_1901920",
               "TVO_1901934",
               "TVO_1902277",
               "TVO_Taiwan19F-14"]
    for strain in strains:
        csv = intaRNA + strain + " files/IntaRNATop_Hit.csv"
        txt = intaRNA + strain + " files/mRNA_target_structure.txt"
        output = intaRNA + strain + " files/mRNA-sRNA_interaction.txt"
        infile1 = open(csv)
        infile2 = open(txt)
        outfile = open(output, "w")
        for _ in range(2): infile1.readline()
        line = infile1.readline().strip()
        parentheses = "()"
        count = 0
        while line:
            interaction = line.split(";")[-1].replace("&", "")
            name = infile2.readline()[1:]
            infile2.readline()
            structure = infile2.readline()
            blank = " " * 25
            interaction = blank + interaction + "\n"
            outfile.write(name)
            outfile.write(structure)
            outfile.write(interaction)
            for i in range(len(interaction)):
                if structure[i] in parentheses and interaction[i] in parentheses:
                    count += 1
                    outfile.write("Overlap!\n")
                    break
            outfile.write("\n")
            line = infile1.readline().strip()
        print(f"{strain}: {count} mRNA-sRNA interacting subsequences having basepairing in structured regions")
    
        infile1.close()
        infile2.close()
        outfile.close()

main()